#!/usr/bin/python
# -* coding: iso-8859-1 -*-
"""
**********************************************************************
File Name:           TEST_RFID.py
Dev:                    Daniele De Santis
Email:                  desantis@areasx.com
Web:                   http://www.areasx.com

Versione:             0.0
Data:                 25/03/11
Note Hardware:        Board SXPY (EXP 2) (dip 5 e 6 a on)
Note Software: 
**********************************************************************
"""
import MOD
import SER
import GPIO
r=GPIO.setIOdir(2,0,1) #setto il port 7 come output e ha come valore di default 0

print "**********************************"
print "Test RFID"
print "v 1.0"
print "dev by DeSantiX.iT"
print 
R=SER.set_speed('9600')
while (1):
  TIMEOUT     = MOD.secCounter()
  RX_DATA     = ""
  RX_LEN      = 14
  while(1):
    RX_DATA = RX_DATA + SER.receive(10)
    if(len(RX_DATA)>=RX_LEN):                  break
    if (MOD.secCounter()>TIMEOUT+5): break #Timeout

  #print "Caratteri RX %d" % len(RX_DATA)
  if(len(RX_DATA)==14):
    if(RX_DATA[0]==chr(0x02) and RX_DATA[13]==chr(0x03)):
      print "**********************************"
      CRC_C = int(RX_DATA[11] + RX_DATA[12], 16)
      print "CRC del TAG %d " % CRC_C
      CRC_T=0
      for i in range(1, 11, 2):
        CRC_T = CRC_T ^  int(RX_DATA[i:2+i], 16)
      print "CRC Calcolato %d " % CRC_T
      print "Valore TAG: %s" % RX_DATA[1:13]
      if(CRC_C==CRC_T):
        print "Numero TAG %010d " % int(RX_DATA[3:11], 16)

        s=GPIO.setIOvalue(2,1)
        MOD.sleep(2)
        s=GPIO.setIOvalue(2,0)
      else:
        print "ERRORE CRC non valido"